=== debian/changelog ===
olm (3.2.1~dfsg-7ubuntu2) hirsute; urgency=medium

  * No change rebuild with fixed ownership.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 16 Feb 2021 17:00:36 +0000

olm (3.2.1~dfsg-7ubuntu1) hirsute; urgency=medium

  * Don't use Ubuntu LDFLAGS for wasm build,
    because they are incompatible with wasm, causing a build failure.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 14 Feb 2021 18:35:26 +0100

olm (3.2.1~dfsg-7) unstable; urgency=medium

  * fix typo in changelog
  * add patches cherry-picked upstream:
    + specify PRIVATE_KEY_LENGTH const export in index.d.ts
    + fix length calculation of fallback key json

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 24 Jan 2021 12:05:34 +0100

olm (3.2.1~dfsg-6) unstable; urgency=medium

  * fix unset executable bit on browser-targeted files
  * fix limit architecture-independently build-depending
    on brotli pigz uglifyjs
  * install libjs-olm demo code as example files

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 27 Dec 2020 13:53:57 +0100

olm (3.2.1~dfsg-5) unstable; urgency=medium

  * fix paths in JavaScript maps,
    and install also compressed WASM files

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 26 Dec 2020 01:36:10 +0100

olm (3.2.1~dfsg-4) unstable; urgency=medium

  * install browser-targeted javascript files also compressed;
    build-depend on brotli pigz uglifyjs
  * fix modernize test skipping syntax;
    closes: bug#977072, thanks to Christian Kastner
  * update git-buildpage settings:
    + use DEP-14 git branch names
    + add usage comment

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 25 Dec 2020 23:01:13 +0100

olm (3.2.1~dfsg-3) unstable; urgency=medium

  * declare compliance with Debian Policy 4.5.1
  * limit build-dependency on emscripten
    to architecture-independent builds
  * fix set custom HOME during build for emscripten,
    and run a dummy emcc command
    to trigger creating emscripten settings file
  * fix avoid dh_auto_install for architecture-independent builds
  * support parallel build for emscripten build;
    build-depend on recent dpkg

 -- Jonas Smedegaard <dr@jones.dk>  Fri, 20 Nov 2020 22:28:00 +0100

olm (3.2.1~dfsg-2) experimental; urgency=medium

  * add patch 1002 to avoid closure-compiler
    (too ancient release packaged in Debian)
  * support DEB_BUILD_OPTIONS=noopt
  * add new binary package libjs-olm;
    build-depend on emscripten

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 27 Oct 2020 21:41:46 +0100

olm (3.2.1~dfsg-1) unstable; urgency=medium

  [ upstream ]
  * new release(s)

  [ Jonas Smedegaard ]
  * add patch 1001 to use python3

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 07 Oct 2020 01:28:48 +0200

olm (3.1.5~dfsg-1) unstable; urgency=medium

  [ upstream ]
  * new release

  [ Jonas Smedegaard ]
  * fix use debhelper compatibility level 13 (not 12)
  * simplify source script copyright-check
  * check tests verbosely, unless DEB_BUILD_OPTIONS=terse
  * fix cleanup after python build
  * use pybuild
  * declare buildsystem explicitly (not in environment)
  * check python testsuite during build;
    build-depend on python3-future python3-pytest
  * use dh_link to install symlink
  * copyright: update coverage

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 29 Aug 2020 16:59:27 +0200
