=== debian/control ===
Source: olm
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Matrix Packaging Team <pkg-matrix-maintainers@lists.alioth.debian.org>
Uploaders:
 Hubert Chathi <uhoreg@debian.org>,
 Jonas Smedegaard <dr@jones.dk>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-sequence-python3,
 python3-all-dev (>= 3.7),
 python3-cffi,
 python3-future <!nocheck>,
 python3-pytest <!nocheck>,
 python3-setuptools,
Build-Depends-Indep:
 brotli,
 dpkg (>= 1.20.1),
 emscripten,
 pigz,
 uglifyjs (>= 3),
Standards-Version: 4.5.1
Section: libs
Homepage: https://matrix.org/git/olm/
Vcs-Git: https://salsa.debian.org/matrix-team/olm.git
Vcs-Browser: https://salsa.debian.org/matrix-team/olm

Package: libolm3
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 libolm2,
Replaces:
 libolm2,
Provides:
 libolm2,
Description: implementation of the Double Ratchet cryptographic ratchet in C++
 Olm is an implementation of the Double Ratchet cryptographic ratchet described
 by https://whispersystems.org/docs/specifications/doubleratchet/, written in C
 and C++11 and exposed as a C API.
 .
 This library also includes an implementation of the Megolm cryptographic
 ratchet which is intended for encrypted messaging applications where there
 may be a large number of recipients of each message, thus precluding the use of
 peer-to-peer encryption systems such as Olm.
 .
 Megolm is the end-to-end encryption system for the Matrix communications
 protocol.
Multi-Arch: same

Package: libolm-dev
Section: libdevel
Architecture: any
Depends:
 libolm3 (= ${binary:Version}),
 ${misc:Depends},
Description: development files for the olm Double Ratchet implementation
 Olm is an implementation of the Double Ratchet cryptographic ratchet described
 by https://whispersystems.org/docs/specifications/doubleratchet/, written in C
 and C++11 and exposed as a C API.
 .
 This library also includes an implementation of the Megolm cryptographic
 ratchet which is intended for encrypted messaging applications where there
 may be a large number of recipients of each message, thus precluding the use of
 peer-to-peer encryption systems such as Olm.
 .
 Megolm is the end-to-end encryption system for the Matrix communications
 protocol.
 .
 This package contains the development files for compiling programs that use
 olm.
Multi-Arch: same

Package: python3-olm
Section: python
Architecture: any
Depends:
 libolm3 (<< ${source:Version}.1~),
 libolm3 (>= ${source:Version}),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Python bindings for the olm Double Ratchet implementation
 Olm is an implementation of the Double Ratchet cryptographic ratchet described
 by https://whispersystems.org/docs/specifications/doubleratchet/, written in C
 and C++11 and exposed as a C API.
 .
 This library also includes an implementation of the Megolm cryptographic
 ratchet which is intended for encrypted messaging applications where there
 may be a large number of recipients of each message, thus precluding the use of
 peer-to-peer encryption systems such as Olm.
 .
 Megolm is the end-to-end encryption system for the Matrix communications
 protocol.
 .
 This package contains the Python 3 bindings for libolm.

Package: libjs-olm
Section: javascript
Architecture: all
Depends:
 ${misc:Depends},
Provides:
 node-olm (= ${source:Version}),
Description: JavaScript compilation of the olm Double Ratchet implementation
 Olm is an implementation of the Double Ratchet cryptographic ratchet described
 by https://whispersystems.org/docs/specifications/doubleratchet/, written in C
 and C++11 and exposed as a C API.
 .
 This library also includes an implementation of the Megolm cryptographic
 ratchet which is intended for encrypted messaging applications where there
 may be a large number of recipients of each message, thus precluding the use of
 peer-to-peer encryption systems such as Olm.
 .
 Megolm is the end-to-end encryption system for the Matrix communications
 protocol.
 .
 This package contains the JavaScript libolm compiled as JavaScript.
